#ifdef __WIN32__
#include <winsock.h>
#else
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#endif
#include "stdio.h"
#include "stdlib.h"
#include "string.h"

#define MAX_PACKET 1024

#define IGRP 9

char ver_iq[] = "IGRP query Version 1.0\n";

typedef struct ip
  {
    char ip_ver;
    char ip_tos;
    short  ip_len;
    short  ip_id;
    short  ip_off;
    char ip_ttl;
    char ip_p;
    short  ip_sum;
    long ip_src,ip_dst;
  }IpHeader;

typedef struct igrp_info {
  u_char ip1,ip2,ip3,d1,d2,d3,b1,b2,b3,m1,m2,r,l,h;
}IgrpHeader_info;

typedef struct igrp {
  u_char ver;
  u_char ed;
  short as;
  short sub;
  short nin;
  short nout;
  short cksum;
}IgrpHeader;

 fd_set fds;
 struct timeval wait;
 int c,rc,sock_raw,timeout,datasize,hlen;
 struct sockaddr_in dest;
 int in_size = sizeof(dest);
 char *recvbuf, *igrp_data, *igrp_inf;
 struct hostent *hp;
 struct ip *hip;

int iq(long *dest_ip, int ttl, int timeout, int as)
{


#ifdef __WIN32__
	 WORD        VersionRequested;
	 WSADATA     ImplementationDetails;
	 VersionRequested = MAKEWORD(1,1);
	 if ( WSAStartup (VersionRequested, &ImplementationDetails) ) {	return(-1);};
#endif

 igrp_data = malloc(MAX_PACKET);
 recvbuf = malloc(MAX_PACKET);
 dest.sin_family = AF_INET;
 dest.sin_addr.s_addr = *dest_ip;
 ((IgrpHeader*)igrp_data)->ver = 0x12;
 ((IgrpHeader*)igrp_data)->ed = 3;
 ((IgrpHeader*)igrp_data)->as = htons(as);
 ((IgrpHeader*)igrp_data)->sub = 0;
 ((IgrpHeader*)igrp_data)->nin = 0;
 ((IgrpHeader*)igrp_data)->nout = 0;
 ((IgrpHeader*)igrp_data)->cksum = 0;
 ((IgrpHeader*)igrp_data)->cksum = checksum((int*)igrp_data,sizeof(struct igrp));
if((sock_raw=socket(AF_INET,SOCK_RAW,IGRP))==-1)
 {perror("send socket()");return(-1);}
if(sendto(sock_raw,igrp_data,sizeof(struct igrp)+sizeof(struct igrp_info),0,(struct sockaddr *)&dest,in_size)<0)
 {perror("send()");return(-1);}
FD_ZERO(&fds);
FD_SET(sock_raw, &fds);
wait.tv_sec = timeout;
wait.tv_usec = 0;
if (select(sock_raw+1, &fds, (fd_set *)0, (fd_set *)0, &wait) > 0)
datasize=recvfrom(sock_raw,recvbuf,MAX_PACKET,0,(struct sockaddr *)&dest,&in_size);
if(!datasize)return(2);
if(datasize==-1)return(1);
hip = (struct ip *) recvbuf;
hlen = ((hip->ip_ver)&0x0F)<<2;
rc = (datasize - hlen - sizeof(struct igrp))/sizeof(struct igrp_info);
igrp_inf=recvbuf + hlen + sizeof(struct igrp);
fprintf(stdout,"ip / delay / band / mtu / reliability / load / hopcount\n");
for(c=0;c<rc;c++)
{
 
 fprintf(stdout,"Routing entry #%d\n\nIP = ",c);
 fprintf(stdout,"%d.",((IgrpHeader_info*)igrp_inf)->ip1);
 fprintf(stdout,"%d.",((IgrpHeader_info*)igrp_inf)->ip2);
 fprintf(stdout,"%d.XX\n",((IgrpHeader_info*)igrp_inf)->ip3);
 fprintf(stdout,"Delay = ");
 fprintf(stdout,"0x%x",((IgrpHeader_info*)igrp_inf)->d1);
 fprintf(stdout,"%x",((IgrpHeader_info*)igrp_inf)->d2);
 
fprintf(stdout,"%x\n",((IgrpHeader_info*)igrp_inf)->d3);
 fprintf(stdout,"Bandwidth = ");
 fprintf(stdout,"0x%x",(((IgrpHeader_info*)igrp_inf)->b1));
 fprintf(stdout,"%x",(((IgrpHeader_info*)igrp_inf)->b2));
 fprintf(stdout,"%x\n",(((IgrpHeader_info*)igrp_inf)->b3));

 fprintf(stdout,"MTU = ");
 fprintf(stdout,"0x%x",(((IgrpHeader_info*)igrp_inf)->m1));
 fprintf(stdout,"%x\n",((IgrpHeader_info*)igrp_inf)->m2);
 
fprintf(stdout,"Reliability = ");
 fprintf(stdout,"%d\n",((IgrpHeader_info*)igrp_inf)->r);
 
fprintf(stdout,"Load = ");
 fprintf(stdout,"%d\n",((IgrpHeader_info*)igrp_inf)->l);
 
fprintf(stdout,"Hop count = ");
 fprintf(stdout,"%d\n\n",((IgrpHeader_info*)igrp_inf)->h);
 igrp_inf+=sizeof(IgrpHeader_info);
};

#ifdef __WIN32__
if((closesocket(sock_raw)==-1))
#else
if((close(sock_raw)==-1))
#endif
  {perror("closesocket()");return(-1);};
return(0);
}

#ifdef IGRP_QUERY
int main(int argc,char* argv[])
{
 long ip;
 if(argc!=5)
 {fprintf(stdout,"usage %s dest ttl timeout as\n",argv[0]);return(-1);};
  fprintf(stdout,ver_iq);
  ip = inet_addr(argv[1]);
 switch (iq(&ip,atoi(argv[2]),atoi(argv[3]),atoi(argv[4])))
        {
            case 0:
		fprintf(stdout,"IGRP is alive");	
                break;
            case 1:
		fprintf(stdout,"Destination unreachable");	
		break;
            case 2:
		fprintf(stdout,"Time out");	            
                break;
            default :
            fprintf(stdout,"Unknow anser\n");	            
                break;
        }
  fprintf(stdout," from %s\n",ltoip(ip));
}
#endif