#ifdef __WIN32__
#include <winsock.h>
#else
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#endif
#include "stdio.h"
#include "stdlib.h"
#include "string.h"

#define MAX_PACKET 1024
#define RIP_UDP_PORT 520


char ver_rq[] = "RIP query Version 1.0\n";

typedef struct rip_info {
  short af;
  short tag;
  long ip;
  long mask;
  long nexthop;
  long metric;
}RIPHeader_info;


typedef struct rip {
  char cmd;
  char ver;
  short rd;
 }RIPHeader;

 fd_set fds;
 struct timeval wait;
 int c,rc,sock_raw,timeout,datasize,hlen;
 struct sockaddr_in dest;
 int in_size = sizeof(dest);
 char *recvbuf;
 char *rip_data, *rip_inf;
 struct hostent *hp;
 
int rq(long *dest_ip, int ttl, int timeout)
{


#ifdef __WIN32__
	 WORD        VersionRequested;
	 WSADATA     ImplementationDetails;
	 VersionRequested = MAKEWORD(1,1);
	 if ( WSAStartup (VersionRequested, &ImplementationDetails) ) {	return(-1);};
#endif

 rip_data = malloc(MAX_PACKET);
 recvbuf = malloc(MAX_PACKET);
 dest.sin_family = AF_INET;
 dest.sin_addr.s_addr = *dest_ip;
 dest.sin_port = htons(RIP_UDP_PORT);
 ((RIPHeader*)rip_data)->cmd = 1;
 ((RIPHeader*)rip_data)->ver = 2;
 ((RIPHeader*)rip_data)->rd = 0;
  rip_inf = rip_data + sizeof(struct rip);
 ((RIPHeader_info*)rip_inf)->af = 0;
 ((RIPHeader_info*)rip_inf)->tag = 0;
 ((RIPHeader_info*)rip_inf)->ip = 0;
 ((RIPHeader_info*)rip_inf)->mask = 0; 
 ((RIPHeader_info*)rip_inf)->nexthop = 0;
 ((RIPHeader_info*)rip_inf)->metric = htonl(16);
if((sock_raw=socket(AF_INET,SOCK_DGRAM,0))==-1)
 {perror("send socket()");return(-1);}
if(sendto(sock_raw,rip_data,sizeof(struct rip)+sizeof(struct rip_info),0,(struct sockaddr *)&dest,in_size)<0)
 {perror("send()");return(-1);}
FD_ZERO(&fds);
FD_SET(sock_raw, &fds);
wait.tv_sec = timeout;
wait.tv_usec = 0;
if (select(sock_raw+1, &fds, (fd_set *)0, (fd_set *)0, &wait) > 0)
datasize=recvfrom(sock_raw,recvbuf,MAX_PACKET,0,(struct sockaddr *)&dest,&in_size);
if(!datasize)return(2);
if(datasize==-1)return(1);
rc = (datasize - sizeof(RIPHeader))/sizeof(RIPHeader_info);
rip_inf=recvbuf + sizeof(struct rip);
fprintf(stdout,"af / tag / ip / mask / nexthop / metric\n");
for(c=0;c<rc;c++)
{
 fprintf(stdout,"%d  ",htons(((RIPHeader_info*)rip_inf)->af));
 fprintf(stdout,"%d  ",htons(((RIPHeader_info*)rip_inf)->tag));
 fprintf(stdout,"%s  ",ltoip(((RIPHeader_info*)rip_inf)->ip));
 fprintf(stdout,"%s  ",ltoip(((RIPHeader_info*)rip_inf)->mask));
 fprintf(stdout,"%s  ",ltoip(((RIPHeader_info*)rip_inf)->nexthop));
 fprintf(stdout,"%d \n",htonl(((RIPHeader_info*)rip_inf)->metric));
rip_inf+=sizeof(RIPHeader_info);
 };
return(0);


#ifdef __WIN32__
if((closesocket(sock_raw)==-1))
#else
if((close(sock_raw)==-1))
#endif
  {perror("closesocket()");return(-1);};
return(-1);
}

#ifdef RIP_QUERY
int main(int argc,char* argv[])
{
 long ip;
 if(argc!=4)
 {fprintf(stdout,"usage %s dest ttl timeout\n",argv[0]);return(-1);};
  fprintf(stdout,ver_rq);
  ip = inet_addr(argv[1]);
  switch (rq(&ip,atoi(argv[2]),atoi(argv[3])))
        {
            case 0:
		fprintf(stdout,"RIP OK");	
                break;
            case 1:
		fprintf(stdout,"RIP protocol unreachable");	
		break;
            case 2:
		fprintf(stdout,"Time out");	            
                break;
            default :
            fprintf(stdout,"Unknow anser\n");	            
                break;
        }
  fprintf(stdout," from %s\n",ltoip(ip));
}
#endif